//          Yasuharu Okamoto, 2020.08
data {
    int a;
    int N;
    real X[N, a];
}
parameters {
    real<lower = 0.0> sgm;
    real tau[a - 1];
    real mu[N];
}
transformed parameters {
    real f_a[a];
    real v = 0.0;
    for (j in 2:a) {
        v += tau[j - 1];
    }
    f_a[1] = -v / a;
    for (j in 2:a) {
        f_a[j] = tau[j - 1] + f_a[1];
    }
}
model {
    sgm ~ exponential(0.001);
    for (i in 1:N) {
        mu[i] ~ normal(0.0, 1000.0);
    }
    for (j in 1:(a-1)){
        tau[j] ~ normal(0.0, 1000.0);
    }
    for (i in 1:N)
        for (j in 1:a) {
            if (j == 1) {
                X[i][j] ~ normal(mu[i], sgm);
            }
            else {
                X[i][j] ~ normal(mu[i] + tau[j-1], sgm);
            }
    }
}
